# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from curie_ros_msgs/RadData.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

from ._CompressedTensor import *
from ._StructuredArray import *
from .std_msgs.msg import *

class RadData(genpy.Message):
  _md5sum = "f402cd30508c2f6095d76a8935248e9f"
  _type = "curie_ros_msgs/RadData"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# General radiological data message built with the curie rad data types in mind
# Listmode data is defined by header/scalars/arrays
# Binmode data is defined by header/scalars/tensor

# TODO there is not currently a header in curie so this is empty
# Originating detector system timestamp and 3D frame
std_msgs/Header header

# Scalar data (length 1)
stark_ros_msgs/StructuredArray scalars

# Array data (arbitrary length)
stark_ros_msgs/StructuredArray arrays

# Tensor data with zero count suppression
stark_ros_msgs/CompressedTensor tensor

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: stark_ros_msgs/StructuredArray
# Structured array of data similar to a numpy structured/record array

# Fields in each element
stark_ros_msgs/StructuredArrayField[] fields

# Number of elements
uint32 length

# Array data, unpacked shape is (length * number of fields)
uint8[] data

# Is the data blob bigendian?
bool is_bigendian

================================================================================
MSG: stark_ros_msgs/StructuredArrayField
# One field/entry in a structured array

# Field name
string name

# dtype from enumeration in DTypes.msg
uint8  dtype

# Number of elements in the field (i.e. a vertex may have 3 values)
# Cannot be zero in numpy
uint32 count

================================================================================
MSG: stark_ros_msgs/CompressedTensor
# N dimensional tensor with zero suppressed encoding

# spec for each axis
stark_ros_msgs/TensorAxis[] axes

# indices (length num fields, each array has N entries)
# this was chosen since this is the result from np.nonzero
stark_ros_msgs/NDArray[] indices

# 1D values at each index (N entries)
# this array determines the tensor dtype
stark_ros_msgs/NDArray values

================================================================================
MSG: stark_ros_msgs/TensorAxis
# axis name
string name

# Centers along axis (required)
stark_ros_msgs/NDArray centers

# Edges around centers (optional)
stark_ros_msgs/NDArray edges

================================================================================
MSG: stark_ros_msgs/NDArray
# Packed, single dtype Numpy array

# dtype from enumeration in DTypes.msg
uint8 dtype

# Array shape
uint64[] shape

# Row(C)/Column(Fortran) major (off by default)
# https://en.wikipedia.org/wiki/Row-_and_column-major_order
bool is_column_major

# Is the data blob bigendian? (off by default)
bool is_bigendian

# Array data
uint8[] data
"""
  __slots__ = ['header','scalars','arrays','tensor']
  _slot_types = ['std_msgs/Header','stark_ros_msgs/StructuredArray','stark_ros_msgs/StructuredArray','stark_ros_msgs/CompressedTensor']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,scalars,arrays,tensor

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RadData, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.scalars is None:
        self.scalars = StructuredArray()
      if self.arrays is None:
        self.arrays = StructuredArray()
      if self.tensor is None:
        self.tensor = CompressedTensor()
    else:
      self.header = std_msgs.msg.Header()
      self.scalars = StructuredArray()
      self.arrays = StructuredArray()
      self.tensor = CompressedTensor()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.scalars.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.scalars.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_BI().pack(_x.dtype, _x.count))
      _x = self.scalars.length
      buff.write(_get_struct_I().pack(_x))
      _x = self.scalars.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.scalars.is_bigendian
      buff.write(_get_struct_B().pack(_x))
      length = len(self.arrays.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.arrays.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_BI().pack(_x.dtype, _x.count))
      _x = self.arrays.length
      buff.write(_get_struct_I().pack(_x))
      _x = self.arrays.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.arrays.is_bigendian
      buff.write(_get_struct_B().pack(_x))
      length = len(self.tensor.axes)
      buff.write(_struct_I.pack(length))
      for val1 in self.tensor.axes:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v1 = val1.centers
        _x = _v1.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v1.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*_v1.shape))
        _x = _v1
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v2 = val1.edges
        _x = _v2.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v2.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*_v2.shape))
        _x = _v2
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v2.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.tensor.indices)
      buff.write(_struct_I.pack(length))
      for val1 in self.tensor.indices:
        _x = val1.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*val1.shape))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.tensor.values.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.tensor.values.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.Struct(pattern).pack(*self.tensor.values.shape))
      _x = self
      buff.write(_get_struct_2B().pack(_x.tensor.values.is_column_major, _x.tensor.values.is_bigendian))
      _x = self.tensor.values.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.scalars is None:
        self.scalars = StructuredArray()
      if self.arrays is None:
        self.arrays = StructuredArray()
      if self.tensor is None:
        self.tensor = CompressedTensor()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.scalars.fields = []
      for i in range(0, length):
        val1 = StructuredArrayField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.dtype, _x.count,) = _get_struct_BI().unpack(str[start:end])
        self.scalars.fields.append(val1)
      start = end
      end += 4
      (self.scalars.length,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.scalars.data = str[start:end]
      start = end
      end += 1
      (self.scalars.is_bigendian,) = _get_struct_B().unpack(str[start:end])
      self.scalars.is_bigendian = bool(self.scalars.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arrays.fields = []
      for i in range(0, length):
        val1 = StructuredArrayField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.dtype, _x.count,) = _get_struct_BI().unpack(str[start:end])
        self.arrays.fields.append(val1)
      start = end
      end += 4
      (self.arrays.length,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.arrays.data = str[start:end]
      start = end
      end += 1
      (self.arrays.is_bigendian,) = _get_struct_B().unpack(str[start:end])
      self.arrays.is_bigendian = bool(self.arrays.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tensor.axes = []
      for i in range(0, length):
        val1 = TensorAxis()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _v3 = val1.centers
        start = end
        end += 1
        (_v3.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v3.shape = s.unpack(str[start:end])
        _x = _v3
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v3.is_column_major = bool(_v3.is_column_major)
        _v3.is_bigendian = bool(_v3.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v3.data = str[start:end]
        _v4 = val1.edges
        start = end
        end += 1
        (_v4.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v4.shape = s.unpack(str[start:end])
        _x = _v4
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v4.is_column_major = bool(_v4.is_column_major)
        _v4.is_bigendian = bool(_v4.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v4.data = str[start:end]
        self.tensor.axes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tensor.indices = []
      for i in range(0, length):
        val1 = NDArray()
        start = end
        end += 1
        (val1.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.shape = s.unpack(str[start:end])
        _x = val1
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        val1.is_column_major = bool(val1.is_column_major)
        val1.is_bigendian = bool(val1.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.tensor.indices.append(val1)
      start = end
      end += 1
      (self.tensor.values.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.tensor.values.shape = s.unpack(str[start:end])
      _x = self
      start = end
      end += 2
      (_x.tensor.values.is_column_major, _x.tensor.values.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.tensor.values.is_column_major = bool(self.tensor.values.is_column_major)
      self.tensor.values.is_bigendian = bool(self.tensor.values.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.tensor.values.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.scalars.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.scalars.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_BI().pack(_x.dtype, _x.count))
      _x = self.scalars.length
      buff.write(_get_struct_I().pack(_x))
      _x = self.scalars.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.scalars.is_bigendian
      buff.write(_get_struct_B().pack(_x))
      length = len(self.arrays.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.arrays.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_BI().pack(_x.dtype, _x.count))
      _x = self.arrays.length
      buff.write(_get_struct_I().pack(_x))
      _x = self.arrays.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.arrays.is_bigendian
      buff.write(_get_struct_B().pack(_x))
      length = len(self.tensor.axes)
      buff.write(_struct_I.pack(length))
      for val1 in self.tensor.axes:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v5 = val1.centers
        _x = _v5.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v5.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(_v5.shape.tostring())
        _x = _v5
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v5.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _v6 = val1.edges
        _x = _v6.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(_v6.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(_v6.shape.tostring())
        _x = _v6
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = _v6.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.tensor.indices)
      buff.write(_struct_I.pack(length))
      for val1 in self.tensor.indices:
        _x = val1.dtype
        buff.write(_get_struct_B().pack(_x))
        length = len(val1.shape)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(val1.shape.tostring())
        _x = val1
        buff.write(_get_struct_2B().pack(_x.is_column_major, _x.is_bigendian))
        _x = val1.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
        else:
          buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.tensor.values.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.tensor.values.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.tensor.values.shape.tostring())
      _x = self
      buff.write(_get_struct_2B().pack(_x.tensor.values.is_column_major, _x.tensor.values.is_bigendian))
      _x = self.tensor.values.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.scalars is None:
        self.scalars = StructuredArray()
      if self.arrays is None:
        self.arrays = StructuredArray()
      if self.tensor is None:
        self.tensor = CompressedTensor()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.scalars.fields = []
      for i in range(0, length):
        val1 = StructuredArrayField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.dtype, _x.count,) = _get_struct_BI().unpack(str[start:end])
        self.scalars.fields.append(val1)
      start = end
      end += 4
      (self.scalars.length,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.scalars.data = str[start:end]
      start = end
      end += 1
      (self.scalars.is_bigendian,) = _get_struct_B().unpack(str[start:end])
      self.scalars.is_bigendian = bool(self.scalars.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.arrays.fields = []
      for i in range(0, length):
        val1 = StructuredArrayField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 5
        (_x.dtype, _x.count,) = _get_struct_BI().unpack(str[start:end])
        self.arrays.fields.append(val1)
      start = end
      end += 4
      (self.arrays.length,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.arrays.data = str[start:end]
      start = end
      end += 1
      (self.arrays.is_bigendian,) = _get_struct_B().unpack(str[start:end])
      self.arrays.is_bigendian = bool(self.arrays.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tensor.axes = []
      for i in range(0, length):
        val1 = TensorAxis()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _v7 = val1.centers
        start = end
        end += 1
        (_v7.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v7.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = _v7
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v7.is_column_major = bool(_v7.is_column_major)
        _v7.is_bigendian = bool(_v7.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v7.data = str[start:end]
        _v8 = val1.edges
        start = end
        end += 1
        (_v8.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        _v8.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = _v8
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        _v8.is_column_major = bool(_v8.is_column_major)
        _v8.is_bigendian = bool(_v8.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v8.data = str[start:end]
        self.tensor.axes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.tensor.indices = []
      for i in range(0, length):
        val1 = NDArray()
        start = end
        end += 1
        (val1.dtype,) = _get_struct_B().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = val1
        start = end
        end += 2
        (_x.is_column_major, _x.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
        val1.is_column_major = bool(val1.is_column_major)
        val1.is_bigendian = bool(val1.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        val1.data = str[start:end]
        self.tensor.indices.append(val1)
      start = end
      end += 1
      (self.tensor.values.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.tensor.values.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      _x = self
      start = end
      end += 2
      (_x.tensor.values.is_column_major, _x.tensor.values.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.tensor.values.is_column_major = bool(self.tensor.values.is_column_major)
      self.tensor.values.is_bigendian = bool(self.tensor.values.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.tensor.values.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_BI = None
def _get_struct_BI():
    global _struct_BI
    if _struct_BI is None:
        _struct_BI = struct.Struct("<BI")
    return _struct_BI
